clear; close all; %pulisco la memoria e chiudo tutti i grafici

%Genero vettori di numeri casuali lunghi da 200 a 4000 elementi
%e applica gli algoritmo di ordinamento bubblesort e quicksort
%misurando i tempi di calcolo (cputime) necessari ad eseguirli

dim=200:200:5000;
for i=1:length(dim)
    x=rand(1,dim(i)); %riempio il vettore considerato di numeri casuali
    
    % calcolo la differenza tra il tempo di calcolo totale utilizzato da
    % Matlab prima di eseguire bubblesort e quello dopo aver eseguito
    % l'algoritmo sul vettore di numeri casuali; il risultato viene salvato
    % nel vettore dei tempi t_bubble
    t = cputime; bubblesort(x); t_bubble(i) = cputime - t;
    
    % calcolo la differenza tra il tempo di calcolo totale utilizzato da
    % Matlab prima di eseguire quicksort e quello dopo aver eseguito
    % l'algoritmo sul vettore di numeri casuali; il risultato viene salvato
    % nel vettore dei tempi t_quick
    t = cputime; quicksort(x); t_quick(i) = cputime - t;
end


%Disegno i tempi di esecuzione dei algoritmi di ordinamento
%eseguiti su vettori di dimensione crescente
%(in rosso bubblesort, in blu quicksort)
plot(dim,t_bubble,'-r',dim,t_quick,'-b'); legend('BubbleSort','QuickSort'); 